WAIT = 0;
GAME = 1;
STATE = WAIT;

frameCount = 0;
FRAME_RATE_START = 10;
FRAME_RATE_INC = 2;
FRAME_RATE = nil;

WIDTH=nil;
HEIGHT=nil;

SCHLAEGER_WIDTH=nil;
SCHLAEGER_HEIGHT=nil;
SCHLAEGER_V=nil;

BALL_R=nil;
BALL_V=5;
ball_x=nil;
ball_y=nil;
ball_vx=nil;
ball_v=1;
ball_vy=nil;


player1_x=nil;
player1_y=nil;
player1_count = 0;
player2_x=nil;
player2_y=nil;
player2_count = 0;

allow_paint = true;

function init()
	
	if(var.recall("frameratestart")==nil) then
		var.store("frameratestart",FRAME_RATE_START);
	end
	FRAME_RATE_START = var.recall("frameratestart");
	if(var.recall("framerateinc")==nil) then
		var.store("framerateinc",FRAME_RATE_INC);
	end
	FRAME_RATE_INC = var.recall("framerateinc");
	if(var.recall("ballv")==nil) then
		var.store("ballv",BALL_V);
	end
	BALL_V = var.recall("ballv");

	WIDTH = platform.window:width();
	HEIGHT = platform.window:height();

	SCHLAEGER_WIDTH = WIDTH/30*4;
	SCHLAEGER_HEIGHT = HEIGHT/30;
	SCHLAEGER_V=WIDTH/20;
	
	BALL_R = WIDTH/100;

	reset();	
	
	timer.start(1/FRAME_RATE);
end

function reset()
	ball_x = WIDTH/2;
	ball_y = HEIGHT/2;
	
	player1_x = WIDTH/2-SCHLAEGER_WIDTH/2;
	player2_x = WIDTH/2-SCHLAEGER_WIDTH/2;
	player1_y = 0;
	player2_y = HEIGHT-SCHLAEGER_HEIGHT;

	ball_vy = 1;
	ball_vx = 0;
	
	STATE = WAIT;	
	
	FRAME_RATE = FRAME_RATE_START;
end;

function on.paint(gc)
	
	if(frameCount == 0) then
		init();
	end	
	gc:drawString(player1_count, SCHLAEGER_WIDTH, SCHLAEGER_HEIGHT, "top")
	gc:drawString(player2_count, WIDTH-SCHLAEGER_WIDTH, HEIGHT-SCHLAEGER_HEIGHT, "bottom")
	gc:fillRect(player1_x,player1_y,SCHLAEGER_WIDTH,SCHLAEGER_HEIGHT);
	gc:fillRect(player2_x,player2_y,SCHLAEGER_WIDTH,SCHLAEGER_HEIGHT);
	if(STATE == GAME) then 
		if (allow_paint) then 
			for i=0, BALL_V, 1 do			
				moveBall();
			end;
		end;
	else
		s = "Press Enter";
		gc:drawString(s, WIDTH/2-gc:getStringWidth(s)/2, HEIGHT/4*3-gc:getStringHeight(s)/2, "top")
	end;
	gc:fillArc(ball_x-BALL_R,ball_y-BALL_R,2*BALL_R,2*BALL_R,0,360);
	
	frameCount = frameCount+1;
	allow_paint = false; 
end

function moveBall()
	ball_x = ball_x + ball_vx;
	ball_y = ball_y + ball_vy;
	if(ball_x-BALL_R<=0) then
		ball_vx = math.abs(ball_vx);
	end
	if(ball_x+BALL_R>=WIDTH) then
		ball_vx = -math.abs(ball_vx);
	end
	if(ball_y-BALL_R<0) then
		player2_count = player2_count + 1;
		reset();
	end
	if(ball_y+BALL_R>HEIGHT) then
		player1_count = player1_count + 1;
		reset();
	end
	collidate1();
	collidate2();
end

function collidate1()
	if(ball_x>=player1_x and ball_x<=player1_x+SCHLAEGER_WIDTH) then
		if(ball_y-BALL_R<=player1_y+SCHLAEGER_HEIGHT) then
			ball_vx = getCos(ball_x-player1_x);
			ball_vy = getSinByCos(ball_vx);
			FRAME_RATE = math.min(100,FRAME_RATE + FRAME_RATE_INC);  
		end;
	end
end

function collidate2()
	if(ball_x>=player2_x and ball_x<=player2_x+SCHLAEGER_WIDTH) then
		if(ball_y+BALL_R>=player2_y) then
			ball_vx = getCos(ball_x-player2_x);
			ball_vy = -getSinByCos(ball_vx); 
			FRAME_RATE = math.min(100,FRAME_RATE + FRAME_RATE_INC);   
		end;
	end
end

function getCos(a)
	cos = (a - SCHLAEGER_WIDTH/2)/(SCHLAEGER_WIDTH/2);
	return cos;
end

function getSinByCos(cos)
	return math.sqrt(1-cos*cos);
end

function on.timer()
	allow_paint = true;
	platform.window:invalidate();
	timer.start(1/FRAME_RATE);
end

function on.tabKey()
   if(STATE == WAIT) then
   	return;
   end
	player1_x = math.max(0,player1_x-SCHLAEGER_V);
	--platform.window:invalidate();
end

function on.backspaceKey()
	if(STATE == WAIT) then
		return;
	end
	player1_x = math.min(WIDTH-SCHLAEGER_WIDTH,player1_x+SCHLAEGER_V);
	--platform.window:invalidate();
end

function on.charIn(ch)
	if(STATE == WAIT) then
		return;
	end
	if(ch=="1") then
		player2_x = math.max(0,player2_x-SCHLAEGER_V);
		--platform.window:invalidate();
	elseif(ch=="3") then
		player2_x = math.min(WIDTH-SCHLAEGER_WIDTH,player2_x+SCHLAEGER_V);
		--platform.window:invalidate();
	end
end

function on.enterKey()
	if(STATE == WAIT) then
		STATE = GAME;
	end
end;